Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision b60dd4ae028d987b1e9bdbd6b71e62f529465109)
+++ src/Makefile.am	(revision 19b56b07dedfce33814935e3ab7bd343e2e37c2b)
@@ -4,7 +4,5 @@
 	config.h \
 	types.h \
-	jackio.h \
 	phasevoc.h \
-	sndfileio.h \
 	mathutils.h \
 	fft.h \
@@ -25,10 +23,6 @@
 libaubio_la_SOURCES = aubio.h \
 	types.h \
-	jackio.c \
-	jackio.h \
 	phasevoc.c \
 	phasevoc.h \
-	sndfileio.c \
-	sndfileio.h \
 	mathutils.c \
 	mathutils.h \
@@ -60,4 +54,4 @@
 	filter.h
 
-AM_CFLAGS = @SNDLIB_CFLAGS@ @JACK_CFLAGS@ @FFTWLIB_CFLAGS@ @SAMPLERATE_CFLAGS@ @LADCCA_CFLAGS@
-libaubio_la_LIBADD = @SNDLIB_LIBS@ @JACK_LIBS@ @FFTWLIB_LIBS@ @SAMPLERATE_LIBS@ @LADCCA_LIBS@ @LTLIBOBJS@
+AM_CFLAGS = @FFTWLIB_CFLAGS@ @SAMPLERATE_CFLAGS@
+libaubio_la_LIBADD = @FFTWLIB_LIBS@ @SAMPLERATE_LIBS@ @LTLIBOBJS@
Index: src/Makefile.in
===================================================================
--- src/Makefile.in	(revision b60dd4ae028d987b1e9bdbd6b71e62f529465109)
+++ src/Makefile.in	(revision 19b56b07dedfce33814935e3ab7bd343e2e37c2b)
@@ -157,7 +157,5 @@
 	config.h \
 	types.h \
-	jackio.h \
 	phasevoc.h \
-	sndfileio.h \
 	mathutils.h \
 	fft.h \
@@ -179,10 +177,6 @@
 libaubio_la_SOURCES = aubio.h \
 	types.h \
-	jackio.c \
-	jackio.h \
 	phasevoc.c \
 	phasevoc.h \
-	sndfileio.c \
-	sndfileio.h \
 	mathutils.c \
 	mathutils.h \
@@ -215,6 +209,6 @@
 
 
-AM_CFLAGS = @SNDLIB_CFLAGS@ @JACK_CFLAGS@ @FFTWLIB_CFLAGS@ @SAMPLERATE_CFLAGS@ @LADCCA_CFLAGS@
-libaubio_la_LIBADD = @SNDLIB_LIBS@ @JACK_LIBS@ @FFTWLIB_LIBS@ @SAMPLERATE_LIBS@ @LADCCA_LIBS@ @LTLIBOBJS@
+AM_CFLAGS = @FFTWLIB_CFLAGS@ @SAMPLERATE_CFLAGS@
+libaubio_la_LIBADD = @FFTWLIB_LIBS@ @SAMPLERATE_LIBS@ @LTLIBOBJS@
 subdir = src
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -226,7 +220,7 @@
 libaubio_la_LDFLAGS =
 libaubio_la_DEPENDENCIES = @LTLIBOBJS@
-am_libaubio_la_OBJECTS = jackio.lo phasevoc.lo sndfileio.lo mathutils.lo \
-	fft.lo sample.lo hist.lo scale.lo resample.lo onsetdetection.lo \
-	tss.lo peakpick.lo biquad.lo pitchdetection.lo pitchmcomb.lo \
+am_libaubio_la_OBJECTS = phasevoc.lo mathutils.lo fft.lo sample.lo \
+	hist.lo scale.lo resample.lo onsetdetection.lo tss.lo \
+	peakpick.lo biquad.lo pitchdetection.lo pitchmcomb.lo \
 	pitchyin.lo filter.lo
 libaubio_la_OBJECTS = $(am_libaubio_la_OBJECTS)
@@ -237,5 +231,5 @@
 @AMDEP_TRUE@DEP_FILES = ./$(DEPDIR)/biquad.Plo ./$(DEPDIR)/fft.Plo \
 @AMDEP_TRUE@	./$(DEPDIR)/filter.Plo ./$(DEPDIR)/hist.Plo \
-@AMDEP_TRUE@	./$(DEPDIR)/jackio.Plo ./$(DEPDIR)/mathutils.Plo \
+@AMDEP_TRUE@	./$(DEPDIR)/mathutils.Plo \
 @AMDEP_TRUE@	./$(DEPDIR)/onsetdetection.Plo \
 @AMDEP_TRUE@	./$(DEPDIR)/peakpick.Plo ./$(DEPDIR)/phasevoc.Plo \
@@ -243,6 +237,5 @@
 @AMDEP_TRUE@	./$(DEPDIR)/pitchmcomb.Plo ./$(DEPDIR)/pitchyin.Plo \
 @AMDEP_TRUE@	./$(DEPDIR)/resample.Plo ./$(DEPDIR)/sample.Plo \
-@AMDEP_TRUE@	./$(DEPDIR)/scale.Plo ./$(DEPDIR)/sndfileio.Plo \
-@AMDEP_TRUE@	./$(DEPDIR)/tss.Plo
+@AMDEP_TRUE@	./$(DEPDIR)/scale.Plo ./$(DEPDIR)/tss.Plo
 COMPILE = $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) \
 	$(CPPFLAGS) $(AM_CFLAGS) $(CFLAGS)
@@ -327,5 +320,4 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/filter.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/hist.Plo@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/jackio.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/mathutils.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/onsetdetection.Plo@am__quote@
@@ -338,5 +330,4 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/sample.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/scale.Plo@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/sndfileio.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/tss.Plo@am__quote@
 
Index: src/aubio.h
===================================================================
--- src/aubio.h	(revision b60dd4ae028d987b1e9bdbd6b71e62f529465109)
+++ src/aubio.h	(revision 19b56b07dedfce33814935e3ab7bd343e2e37c2b)
@@ -68,9 +68,4 @@
 #include "resample.h"
 
-#ifdef JACK_SUPPORT
-#include "jackio.h"
-#endif 
-
-#include "sndfileio.h"
 #include "peakpick.h"
 #include "biquad.h"
Index: src/jackio.c
===================================================================
--- src/jackio.c	(revision b60dd4ae028d987b1e9bdbd6b71e62f529465109)
+++ 	(revision )
@@ -1,175 +1,0 @@
-/*
-   Copyright (C) 2003 Paul Brossier
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2 of the License, or
-   (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-
-*/
-
-#include "config.h"
-#ifdef JACK_SUPPORT
-#include <jack/jack.h>
-#include "aubio_priv.h"
-#include "jackio.h"
-
-/*typedef jack_default_audio_sample_t jack_sample_t; */
-/* work with float, never tried in double */
-typedef smpl_t jack_sample_t;
-
-/**
- * jack device structure 
- */
-struct _aubio_jack_t {
-  /** jack client */
-  jack_client_t *client;
-  /** jack output ports */
-  jack_port_t **oports;
-  /** jack input ports */
-  jack_port_t **iports;
-  /** jack input buffer */
-  jack_sample_t **ibufs;
-  /** jack output buffer */
-  jack_sample_t **obufs;
-  /** jack input channels */
-  uint_t ichan;
-  /** jack output channels */
-  uint_t ochan;
-  /** jack samplerate (Hz) */
-  uint_t samplerate;
-  /** jack processing function */
-  aubio_process_func_t callback; 
-};
-
-/* static memory management */
-static aubio_jack_t * aubio_jack_alloc(uint_t ichan, uint_t ochan);
-static uint_t aubio_jack_free(aubio_jack_t * jack_setup);
-/* jack callback functions */
-static int aubio_jack_process(jack_nframes_t nframes, void *arg);
-static void aubio_jack_shutdown (void *arg);
-
-aubio_jack_t * new_aubio_jack(uint_t ichan, uint_t ochan, 
-    aubio_process_func_t callback) {
-  aubio_jack_t * jack_setup = aubio_jack_alloc (ichan, ochan);
-  uint_t i;
-  char * client_name = "aubio";
-  char name[64];
-  /* initial jack client setup */
-  if ((jack_setup->client = jack_client_new (client_name)) == 0) {
-    AUBIO_ERR ("jack server not running?\n");
-    AUBIO_QUIT(AUBIO_FAIL);
-  }
-
-  /* set callbacks */
-  jack_set_process_callback (jack_setup->client, aubio_jack_process, 
-      (void*) jack_setup);
-  jack_on_shutdown (jack_setup->client, aubio_jack_shutdown, 
-      (void*) jack_setup);
-
-  /* register jack output ports */
-  for (i = 0; i < ochan; i++) 
-  {
-    AUBIO_SPRINTF(name, "out_%d", i+1);
-    AUBIO_MSG("%s\n", name);
-    if ((jack_setup->oports[i] = 
-          jack_port_register (jack_setup->client, name, 
-            JACK_DEFAULT_AUDIO_TYPE, JackPortIsOutput, 0)) == 0) 
-    {
-      AUBIO_ERR("failed registering output port \"%s\"!\n", name);
-      jack_client_close (jack_setup->client);
-      AUBIO_QUIT(AUBIO_FAIL);
-    }
-  }
-
-  /* register jack input ports */
-  for (i = 0; i < ichan; i++) 
-  {
-    AUBIO_SPRINTF(name, "in_%d", i+1);
-    AUBIO_MSG("%s\n", name);
-    if ((jack_setup->iports[i] = 
-          jack_port_register (jack_setup->client, name, 
-            JACK_DEFAULT_AUDIO_TYPE, JackPortIsInput, 0)) == 0)
-    {
-      AUBIO_ERR("failed registering input port \"%s\"!\n", name);
-      jack_client_close (jack_setup->client);
-      AUBIO_QUIT(AUBIO_FAIL);
-    }
-  }
-
-  /* set processing callback */
-  jack_setup->callback = callback;
-  return jack_setup;
-}
-
-uint_t aubio_jack_activate(aubio_jack_t *jack_setup) {
-  /* get sample rate */
-  jack_setup->samplerate = jack_get_sample_rate (jack_setup->client);
-  /* actual jack process activation */
-  if (jack_activate (jack_setup->client)) 
-  {
-    AUBIO_ERR("jack client activation failed");
-    return 1;
-  }
-  return 0;
-}
-
-void aubio_jack_close(aubio_jack_t *jack_setup) {
-  /* bug : should disconnect all ports first */
-  jack_client_close(jack_setup->client);
-  aubio_jack_free(jack_setup);
-}
-
-/* memory management */
-static aubio_jack_t * aubio_jack_alloc(uint_t ichan, uint_t ochan) {
-  aubio_jack_t *jack_setup = AUBIO_NEW(aubio_jack_t);
-  jack_setup->ichan = ichan;
-  jack_setup->ochan = ochan;
-  jack_setup->oports = AUBIO_ARRAY(jack_port_t*, ichan); 
-  jack_setup->iports = AUBIO_ARRAY(jack_port_t*, ochan); 
-  jack_setup->ibufs  = AUBIO_ARRAY(jack_sample_t*, ichan); 
-  jack_setup->obufs  = AUBIO_ARRAY(jack_sample_t*, ochan); 
-  return jack_setup;
-}
-
-static uint_t aubio_jack_free(aubio_jack_t * jack_setup) {
-  AUBIO_FREE(jack_setup->oports);
-  AUBIO_FREE(jack_setup->iports);
-  AUBIO_FREE(jack_setup->ibufs );
-  AUBIO_FREE(jack_setup->obufs );
-  AUBIO_FREE(jack_setup);
-  return AUBIO_OK;
-}
-
-/* jack callback functions */
-static void aubio_jack_shutdown (void *arg){
-  AUBIO_ERR("jack shutdown\n");
-  AUBIO_QUIT(AUBIO_OK);
-}
-
-static int aubio_jack_process(jack_nframes_t nframes, void *arg) {
-  aubio_jack_t* dev = (aubio_jack_t *)arg;
-  uint_t i;
-  for (i=0;i<dev->ichan;i++) { 
-    /* get readable input */
-    dev->ibufs[i] = 
-      (jack_sample_t *) jack_port_get_buffer (dev->iports[i], nframes);
-    /* get writable output */
-    dev->obufs[i] = 
-      (jack_sample_t *) jack_port_get_buffer (dev->oports[i], nframes);
-  }
-  dev->callback(dev->ibufs,dev->obufs,nframes);
-  return 0;
-}
-
-
-#endif /* JACK_SUPPORT */
Index: src/jackio.h
===================================================================
--- src/jackio.h	(revision b60dd4ae028d987b1e9bdbd6b71e62f529465109)
+++ 	(revision )
@@ -1,52 +1,0 @@
-/*
-   Copyright (C) 2003 Paul Brossier
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2 of the License, or
-   (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-
-*/
-
-#ifndef JACKIO_H
-#define JACKIO_H
-
-/** 
- * @file
- *
- * Jack driver for aubio
- * 
- */
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-/** jack object */
-typedef struct _aubio_jack_t aubio_jack_t;
-/** jack process function */
-typedef int (*aubio_process_func_t)(smpl_t **input, smpl_t **output, int
-    nframes);
-
-/** jack device creation function */
-aubio_jack_t * new_aubio_jack (uint_t inchannels, uint_t outchannels,
-    aubio_process_func_t callback);
-/** activate jack client (run jackprocess function) */
-uint_t aubio_jack_activate(aubio_jack_t *jack_setup);
-/** close and delete jack client */
-void aubio_jack_close(aubio_jack_t *jack_setup);
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* JACKIO_H */
Index: src/sndfileio.c
===================================================================
--- src/sndfileio.c	(revision b60dd4ae028d987b1e9bdbd6b71e62f529465109)
+++ 	(revision )
@@ -1,207 +1,0 @@
-/*
-   Copyright (C) 2003 Paul Brossier
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2 of the License, or
-   (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-
-*/
-
-#include <string.h>
-
-#include <sndfile.h>
-
-#include "aubio_priv.h"
-#include "sample.h"
-#include "sndfileio.h"
-#include "mathutils.h"
-
-#define MAX_CHANNELS 6
-#define MAX_SIZE 4096
-
-struct _aubio_file_t {
-        SNDFILE *handle;
-        int samplerate;
-        int channels;
-        int format;
-        float *tmpdata; /** scratch pad for interleaving/deinterleaving. */
-        int size;       /** store the size to check if realloc needed */
-};
-
-aubio_file_t * new_file_ro(const char* outputname) {
-        aubio_file_t * f = AUBIO_NEW(aubio_file_t);
-        SF_INFO sfinfo;
-        AUBIO_MEMSET(&sfinfo, 0, sizeof (sfinfo));
-
-        if (! (f->handle = sf_open (outputname, SFM_READ, &sfinfo))) {
-                AUBIO_ERR("Not able to open input file %s.\n", outputname);
-                AUBIO_ERR("%s\n",sf_strerror (NULL)); /* libsndfile err msg */
-                AUBIO_QUIT(AUBIO_FAIL);
-        }	
-
-        if (sfinfo.channels > MAX_CHANNELS) { 
-                AUBIO_ERR("Not able to process more than %d channels\n", MAX_CHANNELS);
-                AUBIO_QUIT(AUBIO_FAIL);
-        }
-
-        f->size       = MAX_SIZE*sfinfo.channels;
-        f->tmpdata    = AUBIO_ARRAY(float,f->size);
-        /* get input specs */
-        f->samplerate = sfinfo.samplerate;
-        f->channels   = sfinfo.channels;
-        f->format     = sfinfo.format;
-
-        return f;
-}
-
-int file_open_wo(aubio_file_t * f, const char* inputname) {
-        SF_INFO sfinfo;
-        memset (&sfinfo, 0, sizeof (sfinfo));
-
-        /* define file output spec */
-        sfinfo.samplerate = f->samplerate;
-        sfinfo.channels   = f->channels;
-        sfinfo.format     = f->format;
-
-        if (! (f->handle = sf_open (inputname, SFM_WRITE, &sfinfo))) {
-                AUBIO_ERR("Not able to open output file %s.\n", inputname);
-                AUBIO_ERR("%s\n",sf_strerror (NULL)); /* libsndfile err msg */
-                AUBIO_QUIT(AUBIO_FAIL);
-        }	
-
-        if (sfinfo.channels > MAX_CHANNELS) { 
-                AUBIO_ERR("Not able to process more than %d channels\n", MAX_CHANNELS);
-                AUBIO_QUIT(AUBIO_FAIL);
-        }
-        f->size       = MAX_SIZE*sfinfo.channels;
-        f->tmpdata    = AUBIO_ARRAY(float,f->size);
-        return AUBIO_OK;
-}
-
-/* setup file struct from existing one */
-aubio_file_t * new_file_wo(aubio_file_t * fmodel, const char *outputname) {
-        aubio_file_t * f = AUBIO_NEW(aubio_file_t);
-        f->samplerate    = fmodel->samplerate;
-        f->channels      = fmodel->channels;
-        f->format        = fmodel->format;
-        file_open_wo(f, outputname);
-        return f;
-}
-
-
-/* return 0 if properly closed, 1 otherwise */
-int del_file(aubio_file_t * f) {
-        if (sf_close(f->handle)) {
-                AUBIO_ERR("Error closing file.");
-                puts (sf_strerror (NULL));
-                return 1;
-        }
-        AUBIO_FREE(f->tmpdata);
-        AUBIO_FREE(f);
-        //AUBIO_DBG("File closed.\n");
-        return 0;
-}
-
-/**************************************************************
- *
- * Read write methods 
- *
- */
-
-
-/* read frames from file in data 
- *  return the number of frames actually read */
-int file_read(aubio_file_t * f, int frames, fvec_t * read) {
-        sf_count_t read_frames;
-        int i,j, channels = f->channels;
-        int nsamples = frames*channels;
-        int aread;
-        float *pread;	
-
-        /* allocate data for de/interleaving reallocated when needed. */
-        if (nsamples >= f->size) {
-                AUBIO_ERR("Maximum file_read buffer size exceeded.");
-                return -1;
-                /*
-                AUBIO_FREE(f->tmpdata);
-                f->tmpdata = AUBIO_ARRAY(float,nsamples);
-                */
-        }
-        //f->size = nsamples;
-
-        /* do actual reading */
-        read_frames = sf_read_float (f->handle, f->tmpdata, nsamples);
-
-        aread = (int)FLOOR(read_frames/(float)channels);
-
-        /* de-interleaving data  */
-        for (i=0; i<channels; i++) {
-                pread = fvec_get_channel(read,i);
-                for (j=0; j<aread; j++) {
-                        pread[j] = f->tmpdata[channels*j+i];
-                }
-        }
-        return aread;
-}
-
-/* write 'frames' samples to file from data 
- *   return the number of frames actually written 
- */
-int file_write(aubio_file_t * f, int frames, fvec_t * write) {
-        sf_count_t written_frames = 0;
-        int i, j,	channels = f->channels;
-        int nsamples = channels*frames;
-        float *pwrite;
-
-        /* allocate data for de/interleaving reallocated when needed. */
-        if (nsamples >= f->size) {
-                AUBIO_ERR("Maximum file_write buffer size exceeded.");
-                return -1;
-                /*
-                AUBIO_FREE(f->tmpdata);
-                f->tmpdata = AUBIO_ARRAY(float,nsamples);
-                */
-        }
-        //f->size = nsamples;
-
-        /* interleaving data  */
-        for (i=0; i<channels; i++) {
-                pwrite = fvec_get_channel(write,i);
-                for (j=0; j<frames; j++) {
-                        f->tmpdata[channels*j+i] = pwrite[j];
-                }
-        }
-        written_frames = sf_write_float (f->handle, f->tmpdata, nsamples);
-        return written_frames/channels;
-}
-
-/*******************************************************************
- *
- * Get object info 
- *
- */
-
-uint_t aubio_file_channels(aubio_file_t * f) {
-        return f->channels;
-}
-
-uint_t aubio_file_samplerate(aubio_file_t * f) {
-        return f->samplerate;
-}
-
-void file_info(aubio_file_t * f) {
-        AUBIO_DBG("srate    : %d\n", f->samplerate);
-        AUBIO_DBG("channels : %d\n", f->channels);
-        AUBIO_DBG("format   : %d\n", f->format);
-}
-
Index: src/sndfileio.h
===================================================================
--- src/sndfileio.h	(revision b60dd4ae028d987b1e9bdbd6b71e62f529465109)
+++ 	(revision )
@@ -1,73 +1,0 @@
-/*
-	 Copyright (C) 2003 Paul Brossier
-
-	 This program is free software; you can redistribute it and/or modify
-	 it under the terms of the GNU General Public License as published by
-	 the Free Software Foundation; either version 2 of the License, or
-	 (at your option) any later version.
-
-	 This program is distributed in the hope that it will be useful,
-	 but WITHOUT ANY WARRANTY; without even the implied warranty of
-	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-	 GNU General Public License for more details.
-
-	 You should have received a copy of the GNU General Public License
-	 along with this program; if not, write to the Free Software
-	 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-*/
-
-#ifndef SNDFILEIO_H
-#define SNDFILEIO_H
-
-/** @file 
- * sndfile functions
- */
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-/**
- * sndfile object
- */
-typedef struct _aubio_file_t aubio_file_t;
-/** 
- * Open a sound file for reading
- */
-aubio_file_t * new_file_ro (const char * inputfile);
-/**
- * Copy file model from previously opened sound file.
- */
-aubio_file_t * new_file_wo(aubio_file_t * existingfile, const char * outputname);
-/** 
- * Open a sound file for writing
- */
-int file_open_wo (aubio_file_t * file, const char * outputname);
-/** 
- * Read frames data from file 
- */
-int file_read(aubio_file_t * file, int frames, fvec_t * read);
-/** 
- * Write data of length frames to file
- */
-int file_write(aubio_file_t * file, int frames, fvec_t * write);
-/**
- * Close file and delete file object
- */
-int del_file(aubio_file_t * file);
-/**
- * Return some files facts
- */
-void file_info(aubio_file_t * file);
-/**
- * Return number of channel in file
- */
-uint_t aubio_file_channels(aubio_file_t * file);
-uint_t aubio_file_samplerate(aubio_file_t * file);
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif
-