Index: examples/aubiomfcc.c
===================================================================
--- examples/aubiomfcc.c	(revision 2b43a9ecb669387ed0d7fab4dc2df75e90cfc704)
+++ examples/aubiomfcc.c	(revision 029bf4e8ccfb5c3e74de9d6cd45d258b7f8d772d)
@@ -30,6 +30,6 @@
 uint_t n_coefs = 13;
 
-static void
-process_block(fvec_t *ibuf, fvec_t *obuf) {
+void process_block (fvec_t *ibuf, fvec_t *obuf)
+{
   fvec_zeros(obuf);
   //compute mag spectrum
@@ -39,5 +39,6 @@
 }
 
-static void process_print (void) {
+void process_print (void)
+{
   /* output times in seconds and extracted mfccs */
   outmsg("%f\t",blocks*hop_size/(float)samplerate);
Index: examples/aubionotes.c
===================================================================
--- examples/aubionotes.c	(revision 2b43a9ecb669387ed0d7fab4dc2df75e90cfc704)
+++ examples/aubionotes.c	(revision 029bf4e8ccfb5c3e74de9d6cd45d258b7f8d772d)
@@ -46,6 +46,6 @@
 uint_t get_note (fvec_t * note_buffer, fvec_t * note_buffer2);
 
-static void
-process_block(fvec_t *ibuf, fvec_t *obuf) {
+void process_block (fvec_t *ibuf, fvec_t *obuf)
+{
   fvec_zeros(obuf);
   aubio_onset_do(o, ibuf, onset);
@@ -95,6 +95,6 @@
 }
 
-static void
-process_print (void) {
+void process_print (void)
+{
   //if (verbose) outmsg("%f\n",pitch_obuf->data[0]);
 }
Index: examples/aubioonset.c
===================================================================
--- examples/aubioonset.c	(revision 2b43a9ecb669387ed0d7fab4dc2df75e90cfc704)
+++ examples/aubioonset.c	(revision 029bf4e8ccfb5c3e74de9d6cd45d258b7f8d772d)
@@ -30,6 +30,6 @@
 smpl_t is_onset;
 
-void
-process_block(fvec_t *ibuf, fvec_t *obuf) {
+void process_block(fvec_t *ibuf, fvec_t *obuf)
+{
   aubio_onset_do (o, ibuf, onset);
   is_onset = fvec_get_sample(onset, 0);
@@ -47,6 +47,5 @@
 }
 
-void
-process_print (void)
+void process_print (void)
 {
   if ( is_onset ) {
Index: examples/aubiopitch.c
===================================================================
--- examples/aubiopitch.c	(revision 2b43a9ecb669387ed0d7fab4dc2df75e90cfc704)
+++ examples/aubiopitch.c	(revision 029bf4e8ccfb5c3e74de9d6cd45d258b7f8d772d)
@@ -29,6 +29,6 @@
 fvec_t *pitch;
 
-void
-process_block(fvec_t * ibuf, fvec_t * obuf) {
+void process_block(fvec_t * ibuf, fvec_t * obuf)
+{
   aubio_pitch_do (o, ibuf, pitch);
   if ( !usejack && ! sink_uri ) return;
@@ -43,6 +43,6 @@
 }
 
-void
-process_print (void) {
+void process_print (void)
+{
   smpl_t pitch_found = fvec_get_sample(pitch, 0);
   outmsg("%f %f\n",(blocks)
Index: examples/aubioquiet.c
===================================================================
--- examples/aubioquiet.c	(revision 2b43a9ecb669387ed0d7fab4dc2df75e90cfc704)
+++ examples/aubioquiet.c	(revision 029bf4e8ccfb5c3e74de9d6cd45d258b7f8d772d)
@@ -37,5 +37,5 @@
 }
 
-static void process_print (void) {
+void process_print (void) {
   int curblocks = (blocks - 4) > 0 ? blocks - 4 : 0;
   if (issilence == -1) {
Index: examples/parse_args.h
===================================================================
--- examples/parse_args.h	(revision 2b43a9ecb669387ed0d7fab4dc2df75e90cfc704)
+++ examples/parse_args.h	(revision 029bf4e8ccfb5c3e74de9d6cd45d258b7f8d772d)
@@ -48,4 +48,5 @@
 extern void examples_common_process (aubio_process_func_t process_func,
     aubio_print_func_t print);
+int parse_args (int argc, char **argv);
 
 // internal stuff
@@ -57,6 +58,7 @@
 const char *prog_name;
 
-void
-usage (FILE * stream, int exit_code)
+void usage (FILE * stream, int exit_code);
+
+void usage (FILE * stream, int exit_code)
 {
   fprintf (stream, "usage: %s [ options ] \n", prog_name);
Index: examples/utils.c
===================================================================
--- examples/utils.c	(revision 2b43a9ecb669387ed0d7fab4dc2df75e90cfc704)
+++ examples/utils.c	(revision 029bf4e8ccfb5c3e74de9d6cd45d258b7f8d772d)
@@ -73,6 +73,10 @@
 #endif
 
-void
-examples_common_init (int argc, char **argv)
+void examples_common_init (int argc, char **argv);
+void examples_common_del (void);
+void examples_common_process (aubio_process_func_t process_func,
+    aubio_print_func_t print);
+
+void examples_common_init (int argc, char **argv)
 {
 
@@ -116,6 +120,5 @@
 }
 
-void
-examples_common_del (void)
+void examples_common_del (void)
 {
   del_fvec (ibuf);
@@ -126,6 +129,5 @@
 }
 
-void
-examples_common_process (aubio_process_func_t process_func,
+void examples_common_process (aubio_process_func_t process_func,
     aubio_print_func_t print)
 {
Index: examples/utils.h
===================================================================
--- examples/utils.h	(revision 2b43a9ecb669387ed0d7fab4dc2df75e90cfc704)
+++ examples/utils.h	(revision 029bf4e8ccfb5c3e74de9d6cd45d258b7f8d772d)
@@ -54,2 +54,5 @@
 /** common process function */
 typedef int (*aubio_process_func_t) (fvec_t * input, fvec_t * output);
+
+void process_block (fvec_t *ibuf, fvec_t *obuf);
+void process_print (void);