Index: src/aubio_priv.h
===================================================================
--- src/aubio_priv.h	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/aubio_priv.h	(revision 33d02426605c9921044f569805734c5449854646)
@@ -34,5 +34,7 @@
  */
 
+#ifdef HAVE_CONFIG_H
 #include "config.h"
+#endif
 
 #ifdef HAVE_STDLIB_H
Index: src/io/audio_unit.c
===================================================================
--- src/io/audio_unit.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/audio_unit.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,7 +19,6 @@
 */
 
-#include "config.h"
+#include "aubio_priv.h"
 #ifdef HAVE_AUDIO_UNIT
-#include "aubio_priv.h"
 
 #include "fvec.h"
Index: src/io/ioutils.c
===================================================================
--- src/io/ioutils.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/ioutils.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,5 +19,4 @@
 */
 
-#include "config.h"
 #include "aubio_priv.h"
 
Index: src/io/sink.c
===================================================================
--- src/io/sink.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/sink.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,5 +19,4 @@
 */
 
-#include "config.h"
 #include "aubio_priv.h"
 #include "fvec.h"
Index: src/io/sink_apple_audio.c
===================================================================
--- src/io/sink_apple_audio.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/sink_apple_audio.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,9 +19,7 @@
 */
 
-#include "config.h"
+#include "aubio_priv.h"
 
 #ifdef HAVE_SINK_APPLE_AUDIO
-
-#include "aubio_priv.h"
 #include "fvec.h"
 #include "fmat.h"
Index: src/io/sink_sndfile.c
===================================================================
--- src/io/sink_sndfile.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/sink_sndfile.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -20,5 +20,5 @@
 
 
-#include "config.h"
+#include "aubio_priv.h"
 
 #ifdef HAVE_SNDFILE
@@ -26,5 +26,4 @@
 #include <sndfile.h>
 
-#include "aubio_priv.h"
 #include "fvec.h"
 #include "fmat.h"
Index: src/io/sink_wavwrite.c
===================================================================
--- src/io/sink_wavwrite.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/sink_wavwrite.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -20,9 +20,8 @@
 
 
-#include "config.h"
+#include "aubio_priv.h"
 
 #ifdef HAVE_WAVWRITE
 
-#include "aubio_priv.h"
 #include "fvec.h"
 #include "fmat.h"
Index: src/io/source.c
===================================================================
--- src/io/source.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/source.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,5 +19,4 @@
 */
 
-#include "config.h"
 #include "aubio_priv.h"
 #include "fvec.h"
Index: src/io/source_apple_audio.c
===================================================================
--- src/io/source_apple_audio.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/source_apple_audio.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,9 +19,8 @@
 */
 
-#include "config.h"
+#include "aubio_priv.h"
 
 #ifdef HAVE_SOURCE_APPLE_AUDIO
 
-#include "aubio_priv.h"
 #include "fvec.h"
 #include "fmat.h"
Index: src/io/source_avcodec.c
===================================================================
--- src/io/source_avcodec.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/source_avcodec.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,6 +19,5 @@
 */
 
-
-#include "config.h"
+#include "aubio_priv.h"
 
 #ifdef HAVE_LIBAV
Index: src/io/source_sndfile.c
===================================================================
--- src/io/source_sndfile.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/source_sndfile.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,6 +19,5 @@
 */
 
-
-#include "config.h"
+#include "aubio_priv.h"
 
 #ifdef HAVE_SNDFILE
@@ -26,5 +25,4 @@
 #include <sndfile.h>
 
-#include "aubio_priv.h"
 #include "fvec.h"
 #include "fmat.h"
Index: src/io/source_wavread.c
===================================================================
--- src/io/source_wavread.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/source_wavread.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,9 +19,8 @@
 */
 
-#include "config.h"
+#include "aubio_priv.h"
 
 #ifdef HAVE_WAVREAD
 
-#include "aubio_priv.h"
 #include "fvec.h"
 #include "fmat.h"
Index: src/io/utils_apple_audio.c
===================================================================
--- src/io/utils_apple_audio.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/io/utils_apple_audio.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -1,3 +1,3 @@
-#include "config.h"
+#include "aubio_priv.h"
 
 #if defined(HAVE_SOURCE_APPLE_AUDIO) || defined(HAVE_SINK_APPLE_AUDIO)
@@ -7,5 +7,4 @@
 // ExtAudioFileRef, AudioStreamBasicDescription, AudioBufferList, ...
 #include <AudioToolbox/AudioToolbox.h>
-#include "aubio_priv.h"
 
 int createAubioBufferList(AudioBufferList *bufferList, int channels, int segmentSize);
Index: src/mathutils.c
===================================================================
--- src/mathutils.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/mathutils.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -25,5 +25,4 @@
 #include "mathutils.h"
 #include "musicutils.h"
-#include "config.h"
 
 /** Window types */
Index: src/synth/sampler.c
===================================================================
--- src/synth/sampler.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/synth/sampler.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -20,5 +20,4 @@
 
 
-#include "config.h"
 #include "aubio_priv.h"
 #include "fvec.h"
Index: src/synth/wavetable.c
===================================================================
--- src/synth/wavetable.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/synth/wavetable.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -20,5 +20,4 @@
 
 
-#include "config.h"
 #include "aubio_priv.h"
 #include "fvec.h"
Index: src/temporal/resampler.c
===================================================================
--- src/temporal/resampler.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/temporal/resampler.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -18,6 +18,4 @@
 
 */
-
-#include "config.h"
 
 #include "aubio_priv.h"
Index: src/utils/log.c
===================================================================
--- src/utils/log.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/utils/log.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,5 +19,4 @@
 */
 
-#include "config.h"
 #include "aubio_priv.h"
 #include "log.h"
Index: src/utils/parameter.c
===================================================================
--- src/utils/parameter.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/utils/parameter.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -19,5 +19,4 @@
 */
 
-#include "config.h"
 #include "aubio_priv.h"
 #include "parameter.h"
Index: src/utils/windll.c
===================================================================
--- src/utils/windll.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/utils/windll.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -25,5 +25,5 @@
 */
 
-#include "config.h"
+#include "aubio_priv.h"
 
 #ifdef HAVE_WIN_HACKS
Index: src/vecutils.c
===================================================================
--- src/vecutils.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ src/vecutils.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -1,3 +1,2 @@
-#include "config.h"
 #include "aubio_priv.h"
 #include "types.h"
Index: tests/src/io/test-sink_sndfile-multi.c
===================================================================
--- tests/src/io/test-sink_sndfile-multi.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ tests/src/io/test-sink_sndfile-multi.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -1,5 +1,4 @@
 #define AUBIO_UNSTABLE 1
 #include <aubio.h>
-#include "config.h"
 #include "utils_tests.h"
 
Index: tests/src/io/test-sink_sndfile.c
===================================================================
--- tests/src/io/test-sink_sndfile.c	(revision 671eae152ff0396202bcba234303b8070f4de3ad)
+++ tests/src/io/test-sink_sndfile.c	(revision 33d02426605c9921044f569805734c5449854646)
@@ -1,5 +1,4 @@
 #define AUBIO_UNSTABLE 1
 #include <aubio.h>
-#include "config.h"
 #include "utils_tests.h"
 